# Contribution to model development {#Cdev}

<!-- inserting authors list -->
```{r, echo=FALSE, comment="", results='asis'}
insert_chap_authors("Cdev")
insert_chap_reviewers("Cdev")

## Principle and Gouvernance 
 
**Samuel => relecture Bureau** 


*	Stics is opensource => the community is invited to contribute
*	Standard and research versions
*	How to contribute:
  * new development:
    * contact the coordination cell to open a research branch giving the objective of the new development
    * proceed to the development => tools, test, guidelines for development (see next subsection), ...
    * when the development is achieved and thoroughly tested, if you would like to integrate it in the standard version, follow the protocol ...
  * new plant file
    * how to adapt Stics to a new crop / variety: cf. chap 14
	  * protocol
  * new datasets
    * metadata
	  * protocol
* Tools and methods for evaluating and calibrating ... => see chapter 15

Sources : ppt and protocols

## Development tools

### IDE for fortran

### Versionning tools 

Modules development and Branching principle and module integration

### Automatic test and evaluation system


## Coding conventions and good practices

### Naming conventions (files, procedures, variables)
### Variables types, declaration and use (built-in, derived: i.e. structures)
### Code formatting (uniformity, readability, complexity, identation, comments, instructions blocks,... )
### Others: loop, comparisons (reals, doubles)
### Functions/routines: content, arguments mgmnt
### Error management: reading files, tests, ...
### Documentation
#### Using comments in code
#### Documenting structures and functions/routines
#### Write formalisms documentation (Rmd)

## Creating new modules

> **Patrice**
Sources : guidelines for modularisation document

<!-- stand alone -->
### Definition
<!-- a time step functionning -->
### Modules kinds
<!-- atomiques, couplés et propriétés -->
### Modules content
#### Functional modules
* Base functionalities
  * Structures (in, out)
  * Initializations
  * Connect (pointeurs) /vs Get
  * Computation
  * update (ex: using a calculated state variable value for the current time step, for setting the init value of the following time step)

* Extended capabilities
  * Internal calculations
  * Internal storing (delegated to the module)
  * Controls (consistency, bounds, limits, ...)
<!-- time series, sums, cumulatives, ... -->

#### Processes modules
<!-- routines / equations, algo formalismes -->


### Defining functions interfaces ??

### Modules interfacing with other langages (... == routines)

### Testing
<!-- a revoir articulation fotran/interfacing -->
#### Modules compilation ?
#### Component testing
<!-- unit functions/routines -->
#### Module testing
<!-- i.e. functional ?? --> 
#### Module analysis/evaluation
<!-- voir modules Phosphore -->
* Native language
* Using interfacing
<!-- R dynamic lib and methods from R -->

## Integration of new modules or modification in the model

### Integration of new modules

#### Module initializations
<!-- zero , linking inputs and Stics vars , pointers ... -->
#### Calling the compute function
#### Updating Stics variables with module outputs
* Generated by compute
* Stored in historical series, cumulatives, ...
* See for units transformations, calculations for Stics from modules outputs (the module caller converts modules outputs to convenient variables / unit)

### Adding new parameters or output variables

#### Reference lists completion

#### Integrating parameters 
<!-- structure declaration, init, reading, forcing -->

<!-- input files integration: xml, text files reading -->

#### Integrating variables
<!-- structure declaration, init, extracting -->



### Compilation process ...




